export default function useDebounce () {
    return (fn: Function, ms = 300) => {
        let timeoutId: ReturnType<typeof setTimeout>
        return function (this: any, ...args: any[]) {
            clearTimeout(timeoutId)
            timeoutId = setTimeout(() => fn.apply(this, args), ms)
        }
    }
}
