import { DataRectangle, LabeledRect } from '@/pdf-element-marker'
import { getCurrentInstance, reactive, ref, Ref } from 'vue'
import { fabric } from 'fabric'

let model = ref<DataRectangle[]>([])

export default (initCanvas?: Ref<fabric.Canvas | undefined>) => {
    const instance = getCurrentInstance()
    const emit = instance?.emit

    // break me
    // todo Save a model, delete an item, resotre the model and the deleted item returns

    return (instanceCanvas?: fabric.Canvas | undefined) => {
        const canvas = initCanvas?.value ? initCanvas.value : instanceCanvas
        const rects = canvas?.getObjects('labeledRect') as LabeledRect[]
        if (emit && rects) {
            model.value.splice(0)
            model.value.push(...rects.map((rect) => {
                    return reactive<DataRectangle>({
                        angle: rect.angle || 0,
                        color: '' + rect.fill || '',
                        data: rect.data,
                        height: rect.height || 0,
                        isRotatable: rect.isControlVisible('mtr'),
                        label: rect.label,
                        left: rect.left || 0,
                        top: rect.top || 0,
                        width: rect.width || 0,
                    })
                },
            ))
            emit('update:modelValue', model.value)
        }
    }
}
